/**
 * \file protocol_avr911.c
 *
 * \brief AVROSPK
 *
 * ̧قAVR911pLqŋLqAVROSPKւ̋ʐ񋟂AAVROSP
 * 𕜍ēK؂TPI֐Ăт܂B
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "protocol_avr911.h"
#include "RC_Calib.h"
#include "device.h"

/* KŎgpSꎞϐ */
volatile uint16_t address,flash_data,flash_address;
uint8_t high_byte,low_byte;
uint8_t prog_cmd[4];
uint8_t k=0,autoincrement=0;

/* AVROSP(AVR911)ɂđAVR ISPp\߉
** 0x38 0x00 0xXX 0X00 - OSCCALǂݍ
** 0xac 0xe0 0x00 data - {޲ď
** 0x58 0x00 0x00 0x00 - {޲ēǂݍ
** 0xac 0xa0 0x00 data - ˭-ޏ
** 0xac 0xa8 0x00 data - ˭-ޏ
** 0x50 0x00 0x00 0x00 - ˭-ޓǂݍ
** 0x58 0x08 0x00 0x00 - ˭-ޓǂݍ
*/

void universal_command (void)
{
	if(prog_cmd[0]==0x38)
	{
		read_calib_byte0();
		avrosp_send_byte(calib_byte_0);
	}
	else
	{
		if(prog_cmd[0]==0xac)
		{
			switch(prog_cmd[1]){
			case 0xe0:
				program_lockbyte(prog_cmd[3]);
				avrosp_send_byte(0);		// ԂpU
				break;
			case 0xa0:
				erase_config_byte0();
				program_config_byte0(prog_cmd[3]);
				avrosp_send_byte(0);		// ԂpU
				break;
			case 0xa8:
				avrosp_send_byte(0);		// ԂpU
				break;
			}
		}
		else
		{
			if(prog_cmd[0]==0x50)
			{
				read_config_byte0();
				avrosp_send_byte(config_byte_0);
			}
			else
			{
				switch(prog_cmd[1]){
				case 0x00:
					read_lockbyte();
					avrosp_send_byte(lock_byte[1]);
					break;
				case 0x08:
					avrosp_send_byte(0XFF);	// ˭ޏ޲ėpU
					break;
				}
			}
		}
	}
}

/**
 * \brief AVR911KpK擪łB
 *
 * ̊֐νĂ̐VK߂xɎ剞pĂ΂܂B
 */
void avrosp_protocol (uint8_t data)
{
	/* KŎgpꎞϐ */
	uint8_t dummy_read;
	uint8_t osccal_value;

	switch (data)
	{
		/* ʐMJnAʐ̂߂ɓǂݍް𖳎 */
		case 'T' :
			dummy_read = avrosp_receive_byte();
			avrosp_send_byte('\r');
			break;
		/* ۸ݸޓ싖 */
		case 'P' :
			tpi_enable();
			avrosp_send_byte('\r');
			break;
		/* ۸ݸޓ֎~ */
		case 'L' :
			tpi_disable();
			avrosp_send_byte('\r');
			break;
		/* ڽ̎xӖ'Y'ԂB */
		case 'a' :
			avrosp_send_byte('Y');
			autoincrement=1;
			break;
		/* NVMڽݒ */
		case 'A' :
			address = ((uint16_t)avrosp_receive_byte() << 8) ;
			address |= avrosp_receive_byte();
			avrosp_send_byte('\r');
			break;
		/* ް̉޲Ď擾 */
		case 'c' :
			flash_data = avrosp_receive_byte();
			avrosp_send_byte('\r');
			break;
		/* ް̏޲Ă擾Čꏑ݂ */
		case 'C' :
			flash_data |= ((uint16_t)avrosp_receive_byte() << 8) & 0xFF00;
			if(autoincrement) 
			{
				flash_address = NVM_PROG_MEM_START + address;
				autoincrement=0;
			}
			program_code_word(flash_address,flash_data);
			flash_address+=2; 
			avrosp_send_byte('\r');
			break;
		/* 1߰ޏݏIAԂM */
		case 'm' :
			avrosp_send_byte('\r');
			break;
		/* NVM1ǂAVROSPްԂB */
		case 'R' :
			high_byte = read_code_byte(NVM_PROG_MEM_START | (address +1));
			avrosp_send_byte(high_byte);
			low_byte = read_code_byte(NVM_PROG_MEM_START| address);
			avrosp_send_byte(low_byte);
			address+=2;
			break;
		/* ߏJn */
		case 'e' :
			chip_erase();
			avrosp_send_byte('\r');
			break;
		/* 4޲Ė\߂̊Jn */
		case '.' :
			for(uint8_t i=0;i<4;i++)
			 {
			 prog_cmd[i] = avrosp_receive_byte();
			 }
			universal_command();
			avrosp_send_byte('\r');
			break;
		/* AVROSPƂ̋ʐ̂߂ɒ񋟂A˭ޏ޲ */
		case 'N' :
			avrosp_send_byte(0XFF);
			break;
		/* ̏ꍇA݊펯ʎq"AVR ISP"ԂB */
		case 'S' :
			avrosp_send_byte('A');
			avrosp_send_byte('V');
			avrosp_send_byte('R');
			avrosp_send_byte(' ');
			avrosp_send_byte('I');
			avrosp_send_byte('S');
			avrosp_send_byte('P');
			break;
		/* ޲ID擾 */
		case 's' :
			read_device_id();
			avrosp_send_byte(dev_id[2]);
			avrosp_send_byte(dev_id[1]);
			avrosp_send_byte(dev_id[0]);
			break;
		/* RCUZ */
		case 'Y' :
			osccal_value = RC_Calibrate();
			avrosp_send_byte(osccal_value);
//			flash_data = (uint16_t)osccal_value;
//			tpi_enable();
//			chip_erase();
//			flash_address = (OSCCAL_FLASH_ADDR+NVM_PROG_MEM_START);//(uint16_t)flash_end;
//			program_code_word(flash_address,flash_data);
//			tpi_disable();
			break;
		/* ESC̏ꍇɖ */
		case 0x1b:
			break;
		default :
			avrosp_send_byte('\r');
			break;
	}
}
